/* FreeList.h	*/

/* Author:  Marty Kraimer Date:    30MAR1998 */

/*************************************************************************
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory, and the Regents of the University of California, as
* Operator of Los Alamos National Laboratory. MPF is distributed
* subject to a Software License Agreement found in file LICENSE that
* is included with this distribution.
*************************************************************************/
/*
 * Modification Log:
 * -----------------
 * .01  26MAR1998	mrk	Converted freeList from C to C++
 * .02  01MAY2002       mrk     Just call freelist itself
*/

#ifndef INCFreeListH
#define INCFreeListH

#include <freeList.h>

// Like EPICS base freeList except in C++

class FreeListPrivate;

class FreeList
{
public:
    FreeList(int size, int nmalloc) {freeListInitPvt(&pvt,size,nmalloc);}
    ~FreeList() {freeListCleanup(pvt);}
    void *calloc() {return(freeListCalloc(pvt));}
    void *malloc() {return(freeListMalloc(pvt));}
    void free(void *pmem) {freeListFree(pvt,pmem);}
    size_t itemsAvailable() {return(freeListItemsAvail(pvt));}
private:
    void *pvt;
};

#endif /*INCFreeListH*/
